from dune.codegen.generation import (backend)
from dune.codegen.pdelab.quadrature import (name_quadrature_points,
                                            quadrature_iname)
from dune.codegen.blockstructured.geometry import name_point_in_macro
import pymbolic.primitives as prim


@backend(interface="quad_pos", name='blockstructured')
def pymbolic_quadrature_position():
    quad_points = name_quadrature_points()
    quad_iname = quadrature_iname()

    qp_in_micro = prim.Subscript(prim.Variable(quad_points), (prim.Variable(quad_iname),))

    return prim.Variable(name_point_in_macro(qp_in_micro))


@backend(interface="qp_in_cell", name="blockstructured")
def pymbolic_quadrature_position_in_cell(restriction):
    from dune.codegen.pdelab.geometry import to_cell_coordinates
    quad_pos = pymbolic_quadrature_position()
    return to_cell_coordinates(quad_pos, restriction)
